/* REXX glue to use with SHAMVIEW2.0 routines.
   Convert GIF format pics to SHAM format 

Usage: GIFtoSHAM <GIF-FILENAME>

By: E.R. Uber
    1941 W. Morningside Dr.
    Phoenix, AZ  85023
    PLINK: E*R*UBER
*/

RED = '[0;33;40m'
BLK = '[0;32;40m'
DEF = '[0;31;40m'

parse arg 1 f
if arg() = 0 | f = '?' then do
	say BLK'Usage: 'DEF'GIFtoSHAM <'RED'Filename.gif'DEF'>'
	exit 0
end

/* Find filename without .gif extension for use later during rename */
if upper(right(f,4)) = '.GIF' then
	fn = left(f,length(f)-4)
else
	fn = f

say RED'giftotmp 'f f'.tmp'BLK
'giftotmp 'f f'.tmp'

say RED'supercon 'f'.tmp'BLK
'supercon 'f'.tmp'

say RED'rename 'f'.tmp.sham' fn'.sham'BLK
'rename 'f'.tmp.sham' fn'.sham'

/* 'shamview 'f'.sham' DO NOT NEED TO DO THIS SINCE SUPERCON DISPLAYS */

say RED'delete 'f'.tmp'DEF
'delete 'f'.tmp'
