/************************************************/
/*                PLinkZ.REXX                   */
/************************************************/
/* Converts and imports a PLink                 */
/* Library listing into Superbase Professional  */
/* Written by Carl Parramore                    */
/* 1 January 1989                               */
/************************************************/

trace off
call time 'R'
address SBPRO "SET RECORD"
reccount = 0

/* Check for ARP library.  If not loaded, load */
/* If it is not in libs: directory notify user */

lib="libs:rexxsupport.library"
if exists(lib) ~= 1 then nolib()
lib="libs:rexxarplib.library"
if exists(lib) ~= 1 then nolib()

if ~show('L',"rexxsupport.library") then
   call addlib "rexxsupport.library",0,-30
   
if ~show('L',"rexxarplib.library") then
   call addlib "rexxarplib.library",0,-30

do while result ~= ""
	if showlist('P',"SBPRO") ~= 1 then do
		rsb=request(160,55,"SuperBase Professional must be loaded first",,"Okay","Okay")
	exit
	end 

	v6='locate 15,10:? "If you run SBPro from a custom screen you will need"'
	v7='locate 15,11:? "to toggle the Workbench screen foward to load file"'
	address SBPRO v6
	address SBPRO v7

	result=getfile(160,40,"Sys:",,"SBPRO/ARexx - Select file to import")
	if result = "" then do
		address SBPRO "CLS"
		exit
	end
	drop v7
	address SBPRO "CLS"

address SBPRO "SET RECORD"
open(input,result,read)

do until eof(input) = 1
	a=readln(input)                              /* Read a full line */
	a=strip(a)                                   /* Strip leading spaces */
	b=strip(a)

		parse value a with 1 fname +20 fdesc +36 sec +3 fnum +7 fsize 
		fname=strip(fname)
		fdesc=strip(fdesc)
		sec=strip(sec)
		fnum=strip(fnum)
		fsize=strip(fsize)
		if fnum=0 then shutdown()
		send()
end

/* USER DEFINED FUNCTIONS BELOW */

shutdown:

	close(input)
	close(output)
	say
	if time('E') < 60 then do
		etime='Importation Time (in seconds): '||time('E')
		say etime
		v6='locate 20,19:? "'||etime'"'
		address SBPRO v6
	end
	if time('E') >= 60 then do
		etime='Importation Time (in minutes): '||time('E')/60
		say etime
		v6='locate 20,19:? "'||etime'"'
		address SBPRO v6
	end
	exit
/*  END OF PROGRAM */
	
Send:
	reccount = reccount + 1
	address SBPRO "Blank"

	v1='LET File_Name.PLinkLib = "'||fname||'"'

	v2='LET Description.PLinkLib = "'||fdesc'"'

	v3='LET Section.PLinkLib = '||sec

	v4='LET File_Number.PLinkLib = '||fnum

	v5='LET File_Size.PLinkLib = "'||fsize'"'

	v6='locate 29,19:? "Records written = ""'||reccount'"'

	address SBPRO v1
	address SBPRO v2
	address SBPRO v3
	address SBPRO v4
	address SBPRO v5
	
	if rc=0 then do
		say "Records written =" reccount
		address SBPRO v6
	end
	do while rc > 0
		say "AREXX has encountered an error interfacing with"
		say "Superbase Professional"
		say rc
		rc=0
	end

	address SBPRO "STORE"
	address SBPRO "VIEW"
	
return 1

nolib:
	lib=upper(lib)
	msg="REQUEST """ ||lib||" IS MISSING"","""",0,a%"
	address SBPRO msg
	say rc
	say msg
	do x=1 to 100
	end
	exit
	return 0
