/* julian.rexx */
/* converts calendar date from julian date */
month.1 = 'jan'
month.2 = 'feb'
month.3 = 'mar'
month.4 = 'apr'
month.5 = 'may'
month.6 = 'jun'
month.7 = 'jul'
month.8 = 'aug'
month.9 = 'sep'
month.10= 'oct'
month.11= 'nov'
month.12= 'dec'
arg julian daymo hr_min_sec timecode
/* discard day_mo */
/* compute dd-mmm-yy from julian */
/* See pg 26 "Astronomical Formulae for Calculators", by Jean Meeus */
/* 4th ed. Willmann-Bell, Richmond VA 1988. */
alpha = (julian-1867216.25) % 36524.25
a = julian + 1 + alpha - (alpha%4)
b = a + 1524
c = (b-122.1)%365.25
d = (365.25*c)%1
e = (b-d)%30.6001
day = (b - d - ((e*30.6001)%1)) % 1
if e < 13.5 then	mo = e - 1
	    else	mo = e - 13
if mo > 2.5 then	year = c - 4716
	    else	year = c - 4715
/* year = year // 100 */
say day'-'month.mo'-'year

/* rearrange hr_min_sec */
hh = (hr_min_sec / 10000)%1
ss = (hr_min_sec // 100)
mm = (hr_min_sec-(hh*10000))%100
say hh':'mm':'ss
/* combine them in date_n_time */
date_n_time = 'date' day'-'month.mo'-'year hh':'mm':'ss
say date_n_time
